---
updatedAt: 2026-06-18T16:33:19.000Z
agentTools:
  projectIndex: https://docs.lumeo.com/llms.txt
---

# Create Camera Discovery Request

Create a gateway's (cameras) discovery request.

# OpenAPI definition

````json
{
  "openapi": "3.0.3",
  "info": {
    "title": "Lumeo API",
    "version": "1.0",
    "description": "Lumeo is a custom video analytics platform that enables you to rapidly create, deploy,\nand securely manage smart vision-enabled applications. Our vision\nbuilding-blocks remove the development and operational overhead of\nmanaging off-the-shelf IP video cameras and visual data infrastructure for\nyou, and give you a fast, reliable and scalable way to bring vision-enabled\nservices to market.\n\nThe Lumeo API gives you an easy way to control your vision application and\nintegrate cameras, storage, processing and model management with your\napplication.\n\n# Authentication\n\nAll requests to Lumeo's REST API require you to authenticate. You\nauthenticate requests to Lumeo using API Keys which can be created and\nrevoked in the Lumeo Console.\n\n> To authenticate using an API Key, use HTTP Bearer (token) authentication and provide the API\n> key as the token in the Authorization header when making requests to protected resources:\n```\nAuthorization: Bearer <token>\n```\n\n# API Error Codes\n\nWhat errors and status codes can a user expect?\n\n| Error Code                          | Description |\n|-------------------------------------|-------------|\n| HTTP Status Codes for GET Requests  | Description |\n| HTTP Status Codes for POST Requests | Description |\n| Other Inline Error Codes            | Description |\n",
    "contact": {
      "name": "Lumeo",
      "url": "https://www.lumeo.com",
      "email": "support@lumeo.com"
    }
  },
  "servers": [
    {
      "url": "https://api.lumeo.com/v1",
      "description": "Production"
    }
  ],
  "tags": [
    {
      "name": "gateways",
      "description": "Gateways devices / containers that run Pipelines and interface with Cameras."
    }
  ],
  "paths": {
    "/apps/{application_id}/gateways/{gateway_id}/discovery_request": {
      "parameters": [
        {
          "schema": {
            "type": "string"
          },
          "name": "application_id",
          "in": "path",
          "required": true
        },
        {
          "schema": {
            "type": "string"
          },
          "name": "gateway_id",
          "in": "path",
          "required": true
        }
      ],
      "post": {
        "summary": "Create Camera Discovery Request",
        "operationId": "create_discovery_request",
        "responses": {
          "201": {
            "description": "Created",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DiscoveryRequest"
                }
              }
            }
          }
        },
        "description": "Create a gateway's (cameras) discovery request.",
        "security": [
          {
            "api_key": []
          }
        ],
        "tags": [
          "gateways"
        ]
      }
    }
  },
  "components": {
    "securitySchemes": {
      "api_key": {
        "type": "http",
        "scheme": "bearer",
        "description": ""
      }
    },
    "schemas": {
      "UUID": {
        "title": "UUID",
        "type": "object",
        "properties": {
          "id": {
            "type": "string",
            "format": "uuid",
            "example": "f78ef73a-077d-4979-8d4c-bccb8e33301e",
            "description": "An UUIDv4 identifer for this object."
          }
        },
        "required": [
          "id"
        ]
      },
      "Timestamps": {
        "title": "Timestamps",
        "type": "object",
        "properties": {
          "created_at": {
            "type": "string",
            "format": "date-time",
            "example": "2014-03-12T13:37:27+00:00",
            "description": "The time this object was created (ISO 8601)."
          },
          "updated_at": {
            "type": "string",
            "format": "date-time",
            "example": "2014-03-12T13:37:27+00:00",
            "description": "The time this object was last updated at (ISO 8601)."
          }
        },
        "required": [
          "created_at",
          "updated_at"
        ]
      },
      "TagIDs": {
        "description": "A list of tag IDs.",
        "type": "array",
        "example": [
          "74bec053-329a-4c94-86bb-45447fe8bca0",
          "b30a3cee-1eae-4620-afb0-85bfabdb355a"
        ],
        "items": {
          "type": "string",
          "format": "uuid"
        }
      },
      "TagsProperty": {
        "type": "object",
        "description": "The IDs of the tags this entity is tagged with.",
        "properties": {
          "tags": {
            "$ref": "#/components/schemas/TagIDs"
          }
        },
        "required": [
          "tags"
        ]
      },
      "DiscoveryRequestPending": {
        "type": "object",
        "properties": {
          "status": {
            "type": "string",
            "enum": [
              "pending"
            ]
          }
        }
      },
      "ApplicationId": {
        "title": "Application ID",
        "type": "object",
        "properties": {
          "application_id": {
            "type": "string",
            "format": "uuid",
            "description": "The application this model belongs to."
          }
        },
        "required": [
          "application_id"
        ]
      },
      "CameraStatus": {
        "title": "Camera Status",
        "type": "string",
        "enum": [
          "online",
          "offline",
          "unauthorized",
          "unknown"
        ],
        "default": "unknown"
      },
      "CameraCapability": {
        "title": "Camera Capability",
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "description": "Capability name."
          },
          "width": {
            "type": "integer",
            "description": "Width in pixels."
          },
          "height": {
            "type": "integer",
            "description": "Height in pixels."
          },
          "framerates": {
            "type": "array",
            "description": "Supported framerates.",
            "items": {
              "type": "object",
              "properties": {
                "numer": {
                  "type": "integer"
                },
                "denom": {
                  "type": "integer"
                }
              },
              "required": [
                "numer",
                "denom"
              ]
            }
          },
          "format": {
            "type": "string",
            "description": "Video format.",
            "example": "\"MJPG\", \"YUYV\""
          }
        },
        "required": [
          "name",
          "width",
          "height",
          "framerates"
        ],
        "description": "A configuration supported by a specific camera."
      },
      "RtspProtocol": {
        "title": "RtspProtocol",
        "description": "RTSP client protocol",
        "type": "string",
        "enum": [
          "tcp",
          "udp-multicast",
          "udp"
        ]
      },
      "RtspConfig": {
        "title": "RtspConfig",
        "description": "RTSP stream configuration",
        "type": "object",
        "properties": {
          "protocols": {
            "description": "RTSP protocols enabled clientside. Note that specifying `null` or `[]` here will fall back to allowing all supported protocols.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/RtspProtocol"
            },
            "nullable": true
          }
        }
      },
      "RtspCameraConfig": {
        "anyOf": [
          {
            "$ref": "#/components/schemas/RtspConfig"
          }
        ],
        "description": "Default RTSP configuration for RTSP streams associated with this camera."
      },
      "CameraNew": {
        "title": "Camera New",
        "type": "object",
        "properties": {
          "status": {
            "$ref": "#/components/schemas/CameraStatus"
          },
          "name": {
            "type": "string",
            "example": "Warehouse #1",
            "description": "The name of this camera."
          },
          "model": {
            "type": "string",
            "description": "The model number of this camera."
          },
          "conn_type": {
            "type": "string",
            "enum": [
              "local",
              "remote",
              "virtual"
            ],
            "example": "local",
            "description": "The connection type required to use this camera.  If usb type camera, then would be `local` and the `file` field would be used to determine how to access camera.  If remote, then the ip address properties can be used."
          },
          "gateway_id": {
            "type": "string",
            "format": "uuid",
            "description": "If this camera is `local` to a specific gateway, the `gateway_id` is the id of the gateway used to interact with the camera."
          },
          "uri": {
            "type": "string",
            "format": "uri",
            "example": "http://192.168.0.1/onvif/device_service",
            "description": "For local cameras, this is the file path used to access the camera. For IP cameras, this is the address to the ONVIF device service."
          },
          "ip_local": {
            "type": "string",
            "format": "ipv4",
            "example": "192.168.1.56",
            "description": "The local network ip address this camera is using."
          },
          "ip_ext": {
            "type": "string",
            "description": "If this camera is available publicly, this is the external (public) ip address.",
            "format": "ipv4",
            "example": "156.11.15.15"
          },
          "mac_address": {
            "type": "string",
            "description": "The camera's mac address."
          },
          "username": {
            "type": "string",
            "example": "root",
            "description": "The camera's access username."
          },
          "password": {
            "type": "string",
            "description": "The camera's access password.",
            "format": "password"
          },
          "configuration": {
            "type": "string",
            "default": "{}",
            "example": "{}",
            "description": "This is a free-form json (stringified) configuration of the camera."
          },
          "capabilities": {
            "type": "array",
            "description": "The camera's capabilities.",
            "items": {
              "$ref": "#/components/schemas/CameraCapability"
            }
          },
          "external_id": {
            "type": "string",
            "description": "Universal Bridge will associate incoming clips with this identifier.",
            "example": "virtual_camera_1"
          },
          "rtsp_config": {
            "$ref": "#/components/schemas/RtspCameraConfig"
          }
        },
        "required": [
          "uri",
          "conn_type"
        ],
        "description": ""
      },
      "CameraReferenceItems": {
        "title": "Camera Reference Items",
        "type": "object",
        "properties": {
          "reference_pipeline_ids": {
            "type": "array",
            "description": "Universal Bridge will deploy these pipelines for each incoming clip associated with this camera.",
            "example": [
              "a50c18ef-7b12-46ed-a20e-3e3278d289dd",
              "3260bba6-2914-4904-9df1-871f76f5c288"
            ],
            "items": {
              "type": "string",
              "format": "uuid"
            }
          },
          "reference_deployment_ids": {
            "type": "array",
            "description": "Universal Bridge takes configurations from reference deployments when processing a clip.",
            "example": [
              "a9cc4c5b-ca79-45cb-b477-6f6736d58d27",
              "f1625cdb-4f54-42ec-b024-c58c7602b280"
            ],
            "items": {
              "type": "string",
              "format": "uuid"
            }
          }
        }
      },
      "Camera": {
        "title": "Camera",
        "allOf": [
          {
            "$ref": "#/components/schemas/UUID"
          },
          {
            "$ref": "#/components/schemas/ApplicationId"
          },
          {
            "$ref": "#/components/schemas/CameraNew"
          },
          {
            "$ref": "#/components/schemas/Timestamps"
          },
          {
            "$ref": "#/components/schemas/TagsProperty"
          },
          {
            "$ref": "#/components/schemas/CameraReferenceItems"
          },
          {
            "type": "object",
            "properties": {
              "snapshot_file_id": {
                "type": "string",
                "format": "uuid",
                "description": "ID of last taken snapshot. Accessible via '/apps/{application_id}/files/{snapshot_file_id}'."
              }
            }
          }
        ]
      },
      "DiscoveryRequestSuccess": {
        "type": "object",
        "properties": {
          "status": {
            "type": "string",
            "enum": [
              "success"
            ]
          },
          "result": {
            "type": "array",
            "description": "Discovered IP cameras.",
            "items": {
              "$ref": "#/components/schemas/Camera"
            }
          }
        }
      },
      "DiscoveryRequestError": {
        "type": "object",
        "properties": {
          "status": {
            "type": "string",
            "enum": [
              "error"
            ]
          },
          "result": {
            "type": "string",
            "description": "Discovery error."
          }
        }
      },
      "DiscoveryRequest": {
        "title": "Discovery Request",
        "allOf": [
          {
            "type": "object",
            "properties": {
              "id": {
                "type": "string",
                "format": "uuid"
              },
              "expires_at": {
                "type": "string",
                "format": "date-time",
                "example": "2014-03-12T13:37:27+00:00",
                "description": "The time request expires at (ISO 8601). Is equal to 2 hours since creation moment."
              },
              "application_id": {
                "type": "string",
                "format": "uuid",
                "description": "The application this request belongs to."
              },
              "gateway_id": {
                "type": "string",
                "format": "uuid",
                "description": "The gateway this request runs on."
              }
            }
          },
          {
            "oneOf": [
              {
                "$ref": "#/components/schemas/DiscoveryRequestPending"
              },
              {
                "$ref": "#/components/schemas/DiscoveryRequestSuccess"
              },
              {
                "$ref": "#/components/schemas/DiscoveryRequestError"
              }
            ]
          }
        ]
      }
    }
  }
}
````